// ===========================================================================
//	CParamsDialog.h				1996-97 Timo Eloranta
// ===========================================================================
//	This class handles the dialog where the user can view and modify the
//	parameters of a new neural net. CParamsDialog is derived from LGADialogBox
//  - a PowerPlant window class with default (OK) and Cancel buttons.

#pragma once						// Include this header only once

#include <LCaption.h>				
#include <LGADialogBox.h>
#include <LGAEditField.h>
#include <LGAPushButton.h>

#include "NS_Types.h"
#include "CAGASlider.h"

class CParamsDialog : public LGADialogBox {
public:
	enum {
		class_ID = 'PDlg'			// ID used by Metrowerks Constructor
	};

	static 	CParamsDialog * CreateParamsDialogStream( LStream *inStream );
	
					CParamsDialog ( LStream *theStream );
	virtual			~CParamsDialog() {};

	virtual void	InitDialog();
	
	virtual void	SetValues( SGenParams &inParams );
	virtual void	GetValues( SGenParams &outParams );

	virtual void	ListenToMessage( MessageT inMessage, void *ioParam );

	virtual void	FindCommandStatus(CommandT inCommand,
						Boolean &outEnabled, Boolean &outUsesMark,
						Char16 &outMark, Str255 outName);
protected:

	CAGASlider		* mSizeSlider;
	LCaption		* mSizeCapt;

	LGAEditField	* mMinEdit;
	LGAEditField	* mMaxEdit;
	LGAEditField	* mAvg_X_Edit;
	LGAEditField	* mDev_X_Edit;
	LGAEditField	* mAvg_Y_Edit;
	LGAEditField	* mDev_Y_Edit;
	
	LGAPushButton	* mFactoryButton;
	
	virtual void	SetSizeValue( Int16 inValue );
	virtual void	SetDefaultValues();
};
