// ===========================================================================
//	NS_Types.h					1996 Timo Eloranta
// ===========================================================================
//  Types, structs and constants used by the NeuroSim application

#ifndef _H_NS_Types
#define _H_NS_Types

#ifdef __MWERKS__
#pragma once
#endif

#include <PP_Types.h>		// Int16 == short,	Uint16 == unsigned short
							// Int32 == long,	Uint32 == unsigned long

struct	SGenParams {
	Int16	xLengthAvg,		// Average X-length
			yLengthAvg;		// Average Y-length
	Uint16	xLengthDev,		// The amount that the X-length is 
							// allowed to differ (+/-) from xLengthAvg 
			yLengthDev,		// The amount that the Y-length is 
							// allowed to differ (+/-) from yLengthAvg 
			size,			// Size (n x n) of the neuron matrix	
			qtyMin,			// Minimum number of connections
			qtyMax;			// Maximum number of connections ( >= qtyMin )
};

//	 NeuroSim commands

#define cmd_Params					2000
#define cmd_SetParams				-2000
#define cmd_Demo					2001

//	 Resource IDs

#define snd_Click					200
#define snd_Zap						201

#define STRx_Menus					400
#define str_StartDemo				1
#define str_StopDemo				2

#define pane_NeuralNet				1500

#define	WIND_NeuroSim				1000
#define	WIND_NeuroSimAbout			1001
#define WIND_Params					2000

#define ALRT_About					128
#define ALRT_Offscreen				130
#define ALRT_MinMax					131

//	 --- "Parameters" dialog ---

#define slid_Size					2001
#define capt_Size					2002
#define edit_Qty_Min				2003
#define edit_Qty_Max				2004
#define edit_Avg_x					2005
#define edit_Dev_x					2006
#define edit_Avg_y					2007
#define edit_Dev_y					2008

#define pict_Base					200			
#define pict_Slider					201	
#define pict_Selected				202	
#define but_Factory					3097
#define msg_FactorySettings			5000

//   Defaults

#define	DEFAULT_NET_SIZE			10
#define	DEFAULT_QTY_MIN				1
#define	DEFAULT_QTY_MAX				7
#define	DEFAULT_LENGTH_X_AVG		1
#define	DEFAULT_LENGTH_X_DEV		3
#define	DEFAULT_LENGTH_Y_AVG		0
#define	DEFAULT_LENGTH_Y_DEV		4


#endif	// _H_NS_Types
